//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
//
// File: EKF.h
//
// Code generated for Simulink model 'EKF'.
//
// Model version                  : 1.439
// Simulink Coder version         : 8.11 (R2016b) 25-Aug-2016
// C/C++ source code generated on : Wed Mar 15 14:31:33 2017
//
// Target selection: ert.tlc
// Embedded hardware selection: STMicroelectronics->ST10/Super10
// Code generation objectives: Unspecified
// Validation result: Not run
//
#ifndef RTW_HEADER_EKF_h_
#define RTW_HEADER_EKF_h_
#include <cmath>
#include <math.h>
#include <string.h>
#include <stddef.h>
#ifndef EKF_COMMON_INCLUDES_
# define EKF_COMMON_INCLUDES_
#include "rtwtypes.h"
#endif                                 // EKF_COMMON_INCLUDES_

#include "EKF_types.h"
#include "rtGetNaN.h"
#include "rt_nonfinite.h"
#include "rtGetInf.h"

// Macros for accessing real-time model data structure
#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

// Block states (auto storage) for system '<Root>'
typedef struct {
  slcl1F8eFYfz9OcJekEB9zC_EKF_T Power; // '<Root>/MATLAB Function'
  real_T Xhat[3];                      // '<Root>/MATLAB Function'
  real_T P0[9];                        // '<Root>/MATLAB Function'
  real_T P0th;                         // '<Root>/MATLAB Function'
  real_T Current_prev;                 // '<Root>/MATLAB Function'
  real_T Q;                            // '<Root>/MATLAB Function'
  real_T R;                            // '<Root>/MATLAB Function'
  real_T XhatTh;                       // '<Root>/MATLAB Function'
  real_T CthPrev;                      // '<Root>/MATLAB Function'
  real_T iQ;                           // '<Root>/MATLAB Function'
  real_T Qhat;                         // '<Root>/MATLAB Function'
  real_T SumCC;                        // '<Root>/MATLAB Function'
  real_T TimeToUpdateQ;                // '<Root>/MATLAB Function'
  real_T UpdateQ;                      // '<Root>/MATLAB Function'
  real_T Qth;                          // '<Root>/MATLAB Function'
  real_T Rth;                          // '<Root>/MATLAB Function'
  real_T AbsSumCC;                     // '<Root>/MATLAB Function'
  real_T XhatTh_Update;                // '<Root>/MATLAB Function'
  real_T R0_filt_prev;                 // '<Root>/MATLAB Function'
  real_T Current_prev_R;               // '<Root>/MATLAB Function'
  real_T alpha;                        // '<Root>/MATLAB Function'
  real_T PowerDischHat;                // '<Root>/MATLAB Function'
  real_T PowerChHat;                   // '<Root>/MATLAB Function'
  real_T iP;                           // '<Root>/MATLAB Function'
  real_T UpdatePower;                  // '<Root>/MATLAB Function'
  real_T Count;                        // '<Root>/MATLAB Function'
  boolean_T Count_not_empty;           // '<Root>/MATLAB Function'
} DW_EKF_T;

// External inputs (root inport signals with auto storage)
typedef struct {
  real_T Voltage;                      // '<Root>/Voltage'
  real_T Current;                      // '<Root>/Current'
  real_T MacroTime;                    // '<Root>/MacroTime'
  real_T TimeStep;                     // '<Root>/TimeStep'
  real_T TemperatureIn;                // '<Root>/TemperatureIn'
} ExtU_EKF_T;

// External outputs (root outports fed by signals with auto storage)
typedef struct {
  real_T SOC;                          // '<Root>/SOC'
  real_T Q0;                           // '<Root>/Q0'
  real_T R0;                           // '<Root>/R0'
  real_T PowerDisch;                   // '<Root>/PowerDisch'
  real_T PowerCh;                      // '<Root>/PowerCh'
  real_T DegradationIndex;             // '<Root>/DegradationIndex'
} ExtY_EKF_T;

// Real-time Model Data Structure
struct tag_RTM_EKF_T {
  const char_T * volatile errorStatus;
};

// Block states (auto storage)
extern DW_EKF_T EKF_DW;

#ifdef __cplusplus

extern "C" {

#endif

  // External inputs (root inport signals with auto storage)
  extern ExtU_EKF_T EKF_U;

  // External outputs (root outports fed by signals with auto storage)
  extern ExtY_EKF_T EKF_Y;

#ifdef __cplusplus

}
#endif

#ifdef __cplusplus

extern "C" {

#endif

  // Model entry point functions
  extern void EKF_initialize(void);
  extern void EKF_step(void);
  extern void EKF_terminate(void);

#ifdef __cplusplus

}
#endif

// Real-time Model object
#ifdef __cplusplus

extern "C" {

#endif

  extern RT_MODEL_EKF_T *const EKF_M;

#ifdef __cplusplus

}
#endif

//-
//  The generated code includes comments that allow you to trace directly
//  back to the appropriate location in the model.  The basic format
//  is <system>/block_name, where system is the system number (uniquely
//  assigned by Simulink) and block_name is the name of the block.
//
//  Use the MATLAB hilite_system command to trace the generated code back
//  to the model.  For example,
//
//  hilite_system('<S3>')    - opens system 3
//  hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
//
//  Here is the system hierarchy for this model
//
//  '<Root>' : 'EKF'
//  '<S1>'   : 'EKF/MATLAB Function'

#endif                                 // RTW_HEADER_EKF_h_

//
// File trailer for generated code.
//
// [EOF]
//
